# swagger-client
Ingram Micro order management API for creating, reading and deleting orders.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*

This Python package is automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen) project:

- API version: 5.0
- Package version: 1.0.0
- Build package: io.swagger.codegen.v3.generators.python.PythonClientCodegen
For more information, please visit [https://developer.ingrammicro.com/contact](https://developer.ingrammicro.com/contact)

## Requirements.

Python 2.7 and 3.4+

## Installation & Usage
### pip install

If the python package is hosted on Github, you can install directly from Github

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import swagger_client 
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import swagger_client
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python
from __future__ import print_function
import time
import swagger_client
from swagger_client.rest import ApiException
from pprint import pprint

# Configure OAuth2 access token for authorization: application
configuration = swagger_client.Configuration()
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.OrdersApi(swagger_client.ApiClient(configuration))
ordernumber = 'ordernumber_example' # str | Ingram Micro sales order number
customer_number = 'customer_number_example' # str | Your unique Ingram Micro customer number
iso_country_code = 'iso_country_code_example' # str | 2 chars ISO country code
entry_date = '2020-04-03' # str | Order entry date (yyyy-mm-dd) (default to 2020-04-03)

try:
    # Cancel an existing order
    api_response = api_instance.delete_orders_order_number(ordernumber, customer_number, iso_country_code, entry_date)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling OrdersApi->delete_orders_order_number: %s\n" % e)

# Configure OAuth2 access token for authorization: application
configuration = swagger_client.Configuration()
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.OrdersApi(swagger_client.ApiClient(configuration))
customer_number = 'customer_number_example' # str | Your unique Ingram Micro customer number
isocountrycode = 'isocountrycode_example' # str | 2 char iso country code
ordernumber = 'ordernumber_example' # str | Ingram sales order number (optional)
customerordernumber = 'customerordernumber_example' # str | Search using your PO/Order number (optional)
orderstatus = 'any' # str | Ingram Micro order status (optional) (default to any)
startcreatetimestamp = '2013-10-20T19:20:30+01:00' # datetime | Search start date/time in UTC format (optional)
endcreatetimestamp = '2013-10-20T19:20:30+01:00' # datetime | Search end date/time in UTC format (optional)
pagesize = 56 # int | Number of records required in the call (optional)
pagenumber = 1 # int | the page number reference (optional) (default to 1)

try:
    # Search Your Orders
    api_response = api_instance.get_orders_search(customer_number, isocountrycode, ordernumber=ordernumber, customerordernumber=customerordernumber, orderstatus=orderstatus, startcreatetimestamp=startcreatetimestamp, endcreatetimestamp=endcreatetimestamp, pagesize=pagesize, pagenumber=pagenumber)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling OrdersApi->get_orders_search: %s\n" % e)

# Configure OAuth2 access token for authorization: application
configuration = swagger_client.Configuration()
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.OrdersApi(swagger_client.ApiClient(configuration))
ordernumber = 'ordernumber_example' # str | Ingram Micro sales order number
customernumber = '20-222222' # str | Your unique Ingram Micro customer number (default to 20-222222)
isocountrycode = 'US' # str | 2 chars ISO country code (default to US)
customerordernumber = 'customerordernumber_example' # str | Your PO/Order Number provide at the time of order creation (optional)
startcreatetimestamp = '2013-10-20' # date | Filter start date - format YYYY-MM-DD (optional)
endcreatetimestamp = 'endcreatetimestamp_example' # str | Filter end date - format YYYY-MM-DD (optional)

try:
    # Get order details
    api_response = api_instance.get_v5_orders_details(ordernumber, customernumber, isocountrycode, customerordernumber=customerordernumber, startcreatetimestamp=startcreatetimestamp, endcreatetimestamp=endcreatetimestamp)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling OrdersApi->get_v5_orders_details: %s\n" % e)

# Configure OAuth2 access token for authorization: application
configuration = swagger_client.Configuration()
configuration.access_token = 'YOUR_ACCESS_TOKEN'

# create an instance of the API class
api_instance = swagger_client.OrdersApi(swagger_client.ApiClient(configuration))
body = swagger_client.OrderCreateRequest() # OrderCreateRequest |  (optional)

try:
    # Create a new order
    api_response = api_instance.post_v5_orders_create(body=body)
    pprint(api_response)
except ApiException as e:
    print("Exception when calling OrdersApi->post_v5_orders_create: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *https://api.ingrammicro.com:443/sandbox/resellers/v5*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*OrdersApi* | [**delete_orders_order_number**](docs/OrdersApi.md#delete_orders_order_number) | **DELETE** /orders/{ordernumber} | Cancel an existing order
*OrdersApi* | [**get_orders_search**](docs/OrdersApi.md#get_orders_search) | **GET** /orders/search | Search Your Orders
*OrdersApi* | [**get_v5_orders_details**](docs/OrdersApi.md#get_v5_orders_details) | **GET** /orders/{ordernumber} | Get order details
*OrdersApi* | [**post_v5_orders_create**](docs/OrdersApi.md#post_v5_orders_create) | **POST** /orders | Create a new order

## Documentation For Models

 - [OrderCancelResponse](docs/OrderCancelResponse.md)
 - [OrderCancelResponseServiceresponse](docs/OrderCancelResponseServiceresponse.md)
 - [OrderCancelResponseServiceresponseResponsepreamble](docs/OrderCancelResponseServiceresponseResponsepreamble.md)
 - [OrderCreateRequest](docs/OrderCreateRequest.md)
 - [OrderCreateRequestOrdercreaterequest](docs/OrderCreateRequestOrdercreaterequest.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetails](docs/OrderCreateRequestOrdercreaterequestOrdercreatedetails.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetailsEnduser](docs/OrderCreateRequestOrdercreaterequestOrdercreatedetailsEnduser.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetailsExtendedspecs](docs/OrderCreateRequestOrdercreaterequestOrdercreatedetailsExtendedspecs.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetailsLines](docs/OrderCreateRequestOrdercreaterequestOrdercreatedetailsLines.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetailsProductextendedspecs](docs/OrderCreateRequestOrdercreaterequestOrdercreatedetailsProductextendedspecs.md)
 - [OrderCreateRequestOrdercreaterequestOrdercreatedetailsShiptoaddress](docs/OrderCreateRequestOrdercreaterequestOrdercreatedetailsShiptoaddress.md)
 - [OrderCreateRequestOrdercreaterequestRequestpreamble](docs/OrderCreateRequestOrdercreaterequestRequestpreamble.md)
 - [OrderCreateResponse](docs/OrderCreateResponse.md)
 - [OrderCreateResponseServiceresponse](docs/OrderCreateResponseServiceresponse.md)
 - [OrderCreateResponseServiceresponseLines](docs/OrderCreateResponseServiceresponseLines.md)
 - [OrderCreateResponseServiceresponseOrdercreateresponse](docs/OrderCreateResponseServiceresponseOrdercreateresponse.md)
 - [OrderCreateResponseServiceresponseOrdersummary](docs/OrderCreateResponseServiceresponseOrdersummary.md)
 - [OrderCreateResponseServiceresponseOrdersummaryShiptoaddress](docs/OrderCreateResponseServiceresponseOrdersummaryShiptoaddress.md)
 - [OrderCreateResponseServiceresponseResponsepreamble](docs/OrderCreateResponseServiceresponseResponsepreamble.md)
 - [OrderDetailResponse](docs/OrderDetailResponse.md)
 - [OrderDetailResponseServiceresponse](docs/OrderDetailResponseServiceresponse.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponse](docs/OrderDetailResponseServiceresponseOrderdetailresponse.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseBilltoaddress](docs/OrderDetailResponseServiceresponseOrderdetailresponseBilltoaddress.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseCommentlines](docs/OrderDetailResponseServiceresponseOrderdetailresponseCommentlines.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseEnduserinfo](docs/OrderDetailResponseServiceresponseOrderdetailresponseEnduserinfo.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseExtendedspecs](docs/OrderDetailResponseServiceresponseOrderdetailresponseExtendedspecs.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseLines](docs/OrderDetailResponseServiceresponseOrderdetailresponseLines.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseMiscfeeline](docs/OrderDetailResponseServiceresponseOrderdetailresponseMiscfeeline.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponsePackagedetails](docs/OrderDetailResponseServiceresponseOrderdetailresponsePackagedetails.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseProductextendedspecs](docs/OrderDetailResponseServiceresponseOrderdetailresponseProductextendedspecs.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseSerialnumberdetails](docs/OrderDetailResponseServiceresponseOrderdetailresponseSerialnumberdetails.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseShipmentdetails](docs/OrderDetailResponseServiceresponseOrderdetailresponseShipmentdetails.md)
 - [OrderDetailResponseServiceresponseOrderdetailresponseShiptoaddress](docs/OrderDetailResponseServiceresponseOrderdetailresponseShiptoaddress.md)
 - [OrderSearchResponse](docs/OrderSearchResponse.md)
 - [OrderSearchResponseServiceResponse](docs/OrderSearchResponseServiceResponse.md)
 - [OrderSearchResponseServiceResponseOrdersearchresponse](docs/OrderSearchResponseServiceResponseOrdersearchresponse.md)
 - [OrderSearchResponseServiceResponseOrdersearchresponseLinks](docs/OrderSearchResponseServiceResponseOrdersearchresponseLinks.md)
 - [OrderSearchResponseServiceResponseOrdersearchresponseLinks1](docs/OrderSearchResponseServiceResponseOrdersearchresponseLinks1.md)
 - [OrderSearchResponseServiceResponseOrdersearchresponseOrders](docs/OrderSearchResponseServiceResponseOrdersearchresponseOrders.md)
 - [OrderSearchResponseServiceResponseOrdersearchresponseSuborders](docs/OrderSearchResponseServiceResponseOrdersearchresponseSuborders.md)
 - [OrderSearchResponseServiceResponseResponsepreamble](docs/OrderSearchResponseServiceResponseResponsepreamble.md)

## Documentation For Authorization


## application

- **Type**: OAuth
- **Flow**: application
- **Authorization URL**: 
- **Scopes**: 
 - ****: 


## Author


