# coding: utf-8

"""
    Order Management APIs

    Ingram Micro order management API for creating, reading and deleting orders.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*  # noqa: E501

    OpenAPI spec version: 5.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

from __future__ import absolute_import

import re  # noqa: F401

# python 2 and python 3 compatibility library
import six

from swagger_client.api_client import ApiClient


class OrdersApi(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    Ref: https://github.com/swagger-api/swagger-codegen
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient()
        self.api_client = api_client

    def delete_orders_order_number(self, ordernumber, customer_number, iso_country_code, entry_date, **kwargs):  # noqa: E501
        """Cancel an existing order  # noqa: E501

        A request to cancel a previously accepted order, this call must be submitted before the order is released to Ingram Micro’s warehouse.    The order cannot be canceled once it is released to the warehouse.  *Direct ship orders cannot be canceled.  Contact your sales rep for assistance.  *NOTE: orderNumber, isoCountryCode, customerNumber and entryDate is mandatory.*  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_orders_order_number(ordernumber, customer_number, iso_country_code, entry_date, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ordernumber: Ingram Micro sales order number (required)
        :param str customer_number: Your unique Ingram Micro customer number (required)
        :param str iso_country_code: 2 chars ISO country code (required)
        :param str entry_date: Order entry date (yyyy-mm-dd) (required)
        :return: OrderCancelResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.delete_orders_order_number_with_http_info(ordernumber, customer_number, iso_country_code, entry_date, **kwargs)  # noqa: E501
        else:
            (data) = self.delete_orders_order_number_with_http_info(ordernumber, customer_number, iso_country_code, entry_date, **kwargs)  # noqa: E501
            return data

    def delete_orders_order_number_with_http_info(self, ordernumber, customer_number, iso_country_code, entry_date, **kwargs):  # noqa: E501
        """Cancel an existing order  # noqa: E501

        A request to cancel a previously accepted order, this call must be submitted before the order is released to Ingram Micro’s warehouse.    The order cannot be canceled once it is released to the warehouse.  *Direct ship orders cannot be canceled.  Contact your sales rep for assistance.  *NOTE: orderNumber, isoCountryCode, customerNumber and entryDate is mandatory.*  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.delete_orders_order_number_with_http_info(ordernumber, customer_number, iso_country_code, entry_date, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ordernumber: Ingram Micro sales order number (required)
        :param str customer_number: Your unique Ingram Micro customer number (required)
        :param str iso_country_code: 2 chars ISO country code (required)
        :param str entry_date: Order entry date (yyyy-mm-dd) (required)
        :return: OrderCancelResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ordernumber', 'customer_number', 'iso_country_code', 'entry_date']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method delete_orders_order_number" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'ordernumber' is set
        if ('ordernumber' not in params or
                params['ordernumber'] is None):
            raise ValueError("Missing the required parameter `ordernumber` when calling `delete_orders_order_number`")  # noqa: E501
        # verify the required parameter 'customer_number' is set
        if ('customer_number' not in params or
                params['customer_number'] is None):
            raise ValueError("Missing the required parameter `customer_number` when calling `delete_orders_order_number`")  # noqa: E501
        # verify the required parameter 'iso_country_code' is set
        if ('iso_country_code' not in params or
                params['iso_country_code'] is None):
            raise ValueError("Missing the required parameter `iso_country_code` when calling `delete_orders_order_number`")  # noqa: E501
        # verify the required parameter 'entry_date' is set
        if ('entry_date' not in params or
                params['entry_date'] is None):
            raise ValueError("Missing the required parameter `entry_date` when calling `delete_orders_order_number`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ordernumber' in params:
            path_params['ordernumber'] = params['ordernumber']  # noqa: E501

        query_params = []
        if 'customer_number' in params:
            query_params.append(('customerNumber', params['customer_number']))  # noqa: E501
        if 'iso_country_code' in params:
            query_params.append(('isoCountryCode', params['iso_country_code']))  # noqa: E501
        if 'entry_date' in params:
            query_params.append(('entryDate', params['entry_date']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['application']  # noqa: E501

        return self.api_client.call_api(
            '/orders/{ordernumber}', 'DELETE',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='OrderCancelResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_orders_search(self, customer_number, isocountrycode, **kwargs):  # noqa: E501
        """Search Your Orders  # noqa: E501

        Easy to use, and implement order search API endpoint with the capability to search using various parameters, supports pagination. Search using any or all of the parameters below- 1. ordernumber - Ingram Micro sales order number 2. customerordernumber - The PO or order number provided by you when creating an order 3. orderstatus - user order status codes for the search, default is set to \"any\" 4. startcreatetimestamp and endcreatetimestamp - Order create date range  For pagination please use following parameters -  1. pagesize - default 25, max 100 2. pagenumber - default 1  Search mechanism -  1. If no search or filter criteria provided then records are returnedin descending order of creation 2. If all the search parameters are provided then all of them are used for search  Order Status values -  P - PENDING                       R - RELEASED                      4 - SHIPPED                       I - INVOICED                    V - VOIDED                       The search endpoint also return HATEOAS links for order details and invoice details if applicable.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_orders_search(customer_number, isocountrycode, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str customer_number: Your unique Ingram Micro customer number (required)
        :param str isocountrycode: 2 char iso country code (required)
        :param str ordernumber: Ingram sales order number
        :param str customerordernumber: Search using your PO/Order number
        :param str orderstatus: Ingram Micro order status
        :param datetime startcreatetimestamp: Search start date/time in UTC format
        :param datetime endcreatetimestamp: Search end date/time in UTC format
        :param int pagesize: Number of records required in the call
        :param int pagenumber: the page number reference
        :return: OrderSearchResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_orders_search_with_http_info(customer_number, isocountrycode, **kwargs)  # noqa: E501
        else:
            (data) = self.get_orders_search_with_http_info(customer_number, isocountrycode, **kwargs)  # noqa: E501
            return data

    def get_orders_search_with_http_info(self, customer_number, isocountrycode, **kwargs):  # noqa: E501
        """Search Your Orders  # noqa: E501

        Easy to use, and implement order search API endpoint with the capability to search using various parameters, supports pagination. Search using any or all of the parameters below- 1. ordernumber - Ingram Micro sales order number 2. customerordernumber - The PO or order number provided by you when creating an order 3. orderstatus - user order status codes for the search, default is set to \"any\" 4. startcreatetimestamp and endcreatetimestamp - Order create date range  For pagination please use following parameters -  1. pagesize - default 25, max 100 2. pagenumber - default 1  Search mechanism -  1. If no search or filter criteria provided then records are returnedin descending order of creation 2. If all the search parameters are provided then all of them are used for search  Order Status values -  P - PENDING                       R - RELEASED                      4 - SHIPPED                       I - INVOICED                    V - VOIDED                       The search endpoint also return HATEOAS links for order details and invoice details if applicable.   # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_orders_search_with_http_info(customer_number, isocountrycode, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str customer_number: Your unique Ingram Micro customer number (required)
        :param str isocountrycode: 2 char iso country code (required)
        :param str ordernumber: Ingram sales order number
        :param str customerordernumber: Search using your PO/Order number
        :param str orderstatus: Ingram Micro order status
        :param datetime startcreatetimestamp: Search start date/time in UTC format
        :param datetime endcreatetimestamp: Search end date/time in UTC format
        :param int pagesize: Number of records required in the call
        :param int pagenumber: the page number reference
        :return: OrderSearchResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['customer_number', 'isocountrycode', 'ordernumber', 'customerordernumber', 'orderstatus', 'startcreatetimestamp', 'endcreatetimestamp', 'pagesize', 'pagenumber']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_orders_search" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'customer_number' is set
        if ('customer_number' not in params or
                params['customer_number'] is None):
            raise ValueError("Missing the required parameter `customer_number` when calling `get_orders_search`")  # noqa: E501
        # verify the required parameter 'isocountrycode' is set
        if ('isocountrycode' not in params or
                params['isocountrycode'] is None):
            raise ValueError("Missing the required parameter `isocountrycode` when calling `get_orders_search`")  # noqa: E501

        collection_formats = {}

        path_params = {}

        query_params = []
        if 'customer_number' in params:
            query_params.append(('customerNumber', params['customer_number']))  # noqa: E501
        if 'isocountrycode' in params:
            query_params.append(('isocountrycode', params['isocountrycode']))  # noqa: E501
        if 'ordernumber' in params:
            query_params.append(('ordernumber', params['ordernumber']))  # noqa: E501
        if 'customerordernumber' in params:
            query_params.append(('customerordernumber', params['customerordernumber']))  # noqa: E501
        if 'orderstatus' in params:
            query_params.append(('orderstatus', params['orderstatus']))  # noqa: E501
        if 'startcreatetimestamp' in params:
            query_params.append(('startcreatetimestamp', params['startcreatetimestamp']))  # noqa: E501
        if 'endcreatetimestamp' in params:
            query_params.append(('endcreatetimestamp', params['endcreatetimestamp']))  # noqa: E501
        if 'pagesize' in params:
            query_params.append(('pagesize', params['pagesize']))  # noqa: E501
        if 'pagenumber' in params:
            query_params.append(('pagenumber', params['pagenumber']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['application']  # noqa: E501

        return self.api_client.call_api(
            '/orders/search', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='OrderSearchResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def get_v5_orders_details(self, ordernumber, customernumber, isocountrycode, **kwargs):  # noqa: E501
        """Get order details  # noqa: E501

        Retrieve details of an existing order using Ingram Micro sales order number. The sales order number is returned in the order create POST response.   It is highly recommended that you store the IM sales order number. You can also retrieve the IM sales order number by searching your existing order using various parameters including customer PO/order number provided by you at the time of creating the order.  In case the IM sales order number is repeated, you can refine the result by providing customerordernumber for additional filtering and/or using the date range to filter on order creation date.   *NOTE: ordernumber, isocountrycode and customernumber is mandatory.*  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_v5_orders_details(ordernumber, customernumber, isocountrycode, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ordernumber: Ingram Micro sales order number (required)
        :param str customernumber: Your unique Ingram Micro customer number (required)
        :param str isocountrycode: 2 chars ISO country code (required)
        :param str customerordernumber: Your PO/Order Number provide at the time of order creation
        :param date startcreatetimestamp: Filter start date - format YYYY-MM-DD
        :param str endcreatetimestamp: Filter end date - format YYYY-MM-DD
        :return: OrderDetailResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.get_v5_orders_details_with_http_info(ordernumber, customernumber, isocountrycode, **kwargs)  # noqa: E501
        else:
            (data) = self.get_v5_orders_details_with_http_info(ordernumber, customernumber, isocountrycode, **kwargs)  # noqa: E501
            return data

    def get_v5_orders_details_with_http_info(self, ordernumber, customernumber, isocountrycode, **kwargs):  # noqa: E501
        """Get order details  # noqa: E501

        Retrieve details of an existing order using Ingram Micro sales order number. The sales order number is returned in the order create POST response.   It is highly recommended that you store the IM sales order number. You can also retrieve the IM sales order number by searching your existing order using various parameters including customer PO/order number provided by you at the time of creating the order.  In case the IM sales order number is repeated, you can refine the result by providing customerordernumber for additional filtering and/or using the date range to filter on order creation date.   *NOTE: ordernumber, isocountrycode and customernumber is mandatory.*  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.get_v5_orders_details_with_http_info(ordernumber, customernumber, isocountrycode, async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param str ordernumber: Ingram Micro sales order number (required)
        :param str customernumber: Your unique Ingram Micro customer number (required)
        :param str isocountrycode: 2 chars ISO country code (required)
        :param str customerordernumber: Your PO/Order Number provide at the time of order creation
        :param date startcreatetimestamp: Filter start date - format YYYY-MM-DD
        :param str endcreatetimestamp: Filter end date - format YYYY-MM-DD
        :return: OrderDetailResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['ordernumber', 'customernumber', 'isocountrycode', 'customerordernumber', 'startcreatetimestamp', 'endcreatetimestamp']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method get_v5_orders_details" % key
                )
            params[key] = val
        del params['kwargs']
        # verify the required parameter 'ordernumber' is set
        if ('ordernumber' not in params or
                params['ordernumber'] is None):
            raise ValueError("Missing the required parameter `ordernumber` when calling `get_v5_orders_details`")  # noqa: E501
        # verify the required parameter 'customernumber' is set
        if ('customernumber' not in params or
                params['customernumber'] is None):
            raise ValueError("Missing the required parameter `customernumber` when calling `get_v5_orders_details`")  # noqa: E501
        # verify the required parameter 'isocountrycode' is set
        if ('isocountrycode' not in params or
                params['isocountrycode'] is None):
            raise ValueError("Missing the required parameter `isocountrycode` when calling `get_v5_orders_details`")  # noqa: E501

        collection_formats = {}

        path_params = {}
        if 'ordernumber' in params:
            path_params['ordernumber'] = params['ordernumber']  # noqa: E501

        query_params = []
        if 'customernumber' in params:
            query_params.append(('customernumber', params['customernumber']))  # noqa: E501
        if 'isocountrycode' in params:
            query_params.append(('isocountrycode', params['isocountrycode']))  # noqa: E501
        if 'customerordernumber' in params:
            query_params.append(('customerordernumber', params['customerordernumber']))  # noqa: E501
        if 'startcreatetimestamp' in params:
            query_params.append(('startcreatetimestamp', params['startcreatetimestamp']))  # noqa: E501
        if 'endcreatetimestamp' in params:
            query_params.append(('endcreatetimestamp', params['endcreatetimestamp']))  # noqa: E501

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['application']  # noqa: E501

        return self.api_client.call_api(
            '/orders/{ordernumber}', 'GET',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='OrderDetailResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)

    def post_v5_orders_create(self, **kwargs):  # noqa: E501
        """Create a new order  # noqa: E501

        Use POST order create API for instant ordering with Ingram Micro. The API supports stocked SKUs as well as licensing and warranties SKUs. It is highly recommended to provide \"ingrampartnumber\" for the SKUs.  For using vendorpartnumber to place the orders, please use the product search endpoint to find the ingrampartnumber for a specific vendorpartnumber and then supply the ingrampartnumber to place an order.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_v5_orders_create(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrderCreateRequest body:
        :return: OrderCreateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """
        kwargs['_return_http_data_only'] = True
        if kwargs.get('async_req'):
            return self.post_v5_orders_create_with_http_info(**kwargs)  # noqa: E501
        else:
            (data) = self.post_v5_orders_create_with_http_info(**kwargs)  # noqa: E501
            return data

    def post_v5_orders_create_with_http_info(self, **kwargs):  # noqa: E501
        """Create a new order  # noqa: E501

        Use POST order create API for instant ordering with Ingram Micro. The API supports stocked SKUs as well as licensing and warranties SKUs. It is highly recommended to provide \"ingrampartnumber\" for the SKUs.  For using vendorpartnumber to place the orders, please use the product search endpoint to find the ingrampartnumber for a specific vendorpartnumber and then supply the ingrampartnumber to place an order.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True
        >>> thread = api.post_v5_orders_create_with_http_info(async_req=True)
        >>> result = thread.get()

        :param async_req bool
        :param OrderCreateRequest body:
        :return: OrderCreateResponse
                 If the method is called asynchronously,
                 returns the request thread.
        """

        all_params = ['body']  # noqa: E501
        all_params.append('async_req')
        all_params.append('_return_http_data_only')
        all_params.append('_preload_content')
        all_params.append('_request_timeout')

        params = locals()
        for key, val in six.iteritems(params['kwargs']):
            if key not in all_params:
                raise TypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method post_v5_orders_create" % key
                )
            params[key] = val
        del params['kwargs']

        collection_formats = {}

        path_params = {}

        query_params = []

        header_params = {}

        form_params = []
        local_var_files = {}

        body_params = None
        if 'body' in params:
            body_params = params['body']
        # HTTP header `Accept`
        header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # HTTP header `Content-Type`
        header_params['Content-Type'] = self.api_client.select_header_content_type(  # noqa: E501
            ['application/json'])  # noqa: E501

        # Authentication setting
        auth_settings = ['application']  # noqa: E501

        return self.api_client.call_api(
            '/orders', 'POST',
            path_params,
            query_params,
            header_params,
            body=body_params,
            post_params=form_params,
            files=local_var_files,
            response_type='OrderCreateResponse',  # noqa: E501
            auth_settings=auth_settings,
            async_req=params.get('async_req'),
            _return_http_data_only=params.get('_return_http_data_only'),
            _preload_content=params.get('_preload_content', True),
            _request_timeout=params.get('_request_timeout'),
            collection_formats=collection_formats)
