# coding: utf-8

"""
    Order Management APIs

    Ingram Micro order management API for creating, reading and deleting orders.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*  # noqa: E501

    OpenAPI spec version: 5.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class OrderSearchResponseServiceResponseOrdersearchresponseLinks(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'topic': 'str',
        'href': 'str',
        'type': 'str'
    }

    attribute_map = {
        'topic': 'topic',
        'href': 'href',
        'type': 'type'
    }

    def __init__(self, topic=None, href=None, type=None):  # noqa: E501
        """OrderSearchResponseServiceResponseOrdersearchresponseLinks - a model defined in Swagger"""  # noqa: E501
        self._topic = None
        self._href = None
        self._type = None
        self.discriminator = None
        if topic is not None:
            self.topic = topic
        if href is not None:
            self.href = href
        if type is not None:
            self.type = type

    @property
    def topic(self):
        """Gets the topic of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.  # noqa: E501

        topic being orders or invoices, if it is orders then the link will provide details of the order. If its invoices then the link provides details of the invoice  # noqa: E501

        :return: The topic of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.  # noqa: E501
        :rtype: str
        """
        return self._topic

    @topic.setter
    def topic(self, topic):
        """Sets the topic of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.

        topic being orders or invoices, if it is orders then the link will provide details of the order. If its invoices then the link provides details of the invoice  # noqa: E501

        :param topic: The topic of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.  # noqa: E501
        :type: str
        """
        allowed_values = ["orders", "invoices"]  # noqa: E501
        if topic not in allowed_values:
            raise ValueError(
                "Invalid value for `topic` ({0}), must be one of {1}"  # noqa: E501
                .format(topic, allowed_values)
            )

        self._topic = topic

    @property
    def href(self):
        """Gets the href of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.  # noqa: E501

        The API endpoint for accessing the relevant data  # noqa: E501

        :return: The href of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.  # noqa: E501
        :rtype: str
        """
        return self._href

    @href.setter
    def href(self, href):
        """Sets the href of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.

        The API endpoint for accessing the relevant data  # noqa: E501

        :param href: The href of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.  # noqa: E501
        :type: str
        """

        self._href = href

    @property
    def type(self):
        """Gets the type of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.  # noqa: E501

        The type of call that can be made to the href link  # noqa: E501

        :return: The type of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.  # noqa: E501
        :rtype: str
        """
        return self._type

    @type.setter
    def type(self, type):
        """Sets the type of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.

        The type of call that can be made to the href link  # noqa: E501

        :param type: The type of this OrderSearchResponseServiceResponseOrdersearchresponseLinks.  # noqa: E501
        :type: str
        """
        allowed_values = ["GET", "POST", "PUT"]  # noqa: E501
        if type not in allowed_values:
            raise ValueError(
                "Invalid value for `type` ({0}), must be one of {1}"  # noqa: E501
                .format(type, allowed_values)
            )

        self._type = type

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrderSearchResponseServiceResponseOrdersearchresponseLinks, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderSearchResponseServiceResponseOrdersearchresponseLinks):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
