# coding: utf-8

"""
    Order Management APIs

    Ingram Micro order management API for creating, reading and deleting orders.  *Production URL - https://api.ingrammicro.com:443/resellers/v5*  # noqa: E501

    OpenAPI spec version: 5.0
    
    Generated by: https://github.com/swagger-api/swagger-codegen.git
"""

import pprint
import re  # noqa: F401

import six


class OrderSearchResponseServiceResponseOrdersearchresponseOrders(object):
    """NOTE: This class is auto generated by the swagger code generator program.

    Do not edit the class manually.
    """
    """
    Attributes:
      swagger_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    swagger_types = {
        'ordernumber': 'str',
        'entrytimestamp': 'str',
        'customerordernumber': 'str',
        'suborders': 'list[OrderSearchResponseServiceResponseOrdersearchresponseSuborders]',
        'links': 'OrderSearchResponseServiceResponseOrdersearchresponseLinks1'
    }

    attribute_map = {
        'ordernumber': 'ordernumber',
        'entrytimestamp': 'entrytimestamp',
        'customerordernumber': 'customerordernumber',
        'suborders': 'suborders',
        'links': 'links'
    }

    def __init__(self, ordernumber=None, entrytimestamp=None, customerordernumber=None, suborders=None, links=None):  # noqa: E501
        """OrderSearchResponseServiceResponseOrdersearchresponseOrders - a model defined in Swagger"""  # noqa: E501
        self._ordernumber = None
        self._entrytimestamp = None
        self._customerordernumber = None
        self._suborders = None
        self._links = None
        self.discriminator = None
        self.ordernumber = ordernumber
        self.entrytimestamp = entrytimestamp
        if customerordernumber is not None:
            self.customerordernumber = customerordernumber
        if suborders is not None:
            self.suborders = suborders
        if links is not None:
            self.links = links

    @property
    def ordernumber(self):
        """Gets the ordernumber of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501

        Ingram micro sales order number  # noqa: E501

        :return: The ordernumber of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501
        :rtype: str
        """
        return self._ordernumber

    @ordernumber.setter
    def ordernumber(self, ordernumber):
        """Sets the ordernumber of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.

        Ingram micro sales order number  # noqa: E501

        :param ordernumber: The ordernumber of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501
        :type: str
        """
        if ordernumber is None:
            raise ValueError("Invalid value for `ordernumber`, must not be `None`")  # noqa: E501

        self._ordernumber = ordernumber

    @property
    def entrytimestamp(self):
        """Gets the entrytimestamp of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501

        The order creation date-time in UTC format  # noqa: E501

        :return: The entrytimestamp of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501
        :rtype: str
        """
        return self._entrytimestamp

    @entrytimestamp.setter
    def entrytimestamp(self, entrytimestamp):
        """Sets the entrytimestamp of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.

        The order creation date-time in UTC format  # noqa: E501

        :param entrytimestamp: The entrytimestamp of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501
        :type: str
        """
        if entrytimestamp is None:
            raise ValueError("Invalid value for `entrytimestamp`, must not be `None`")  # noqa: E501

        self._entrytimestamp = entrytimestamp

    @property
    def customerordernumber(self):
        """Gets the customerordernumber of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501

        PO/Order number submitted while creating the order  # noqa: E501

        :return: The customerordernumber of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501
        :rtype: str
        """
        return self._customerordernumber

    @customerordernumber.setter
    def customerordernumber(self, customerordernumber):
        """Sets the customerordernumber of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.

        PO/Order number submitted while creating the order  # noqa: E501

        :param customerordernumber: The customerordernumber of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501
        :type: str
        """

        self._customerordernumber = customerordernumber

    @property
    def suborders(self):
        """Gets the suborders of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501

        An order MAY get divided into various sub orders, for example if the SKUs are being shipped from different warehouse.  # noqa: E501

        :return: The suborders of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501
        :rtype: list[OrderSearchResponseServiceResponseOrdersearchresponseSuborders]
        """
        return self._suborders

    @suborders.setter
    def suborders(self, suborders):
        """Sets the suborders of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.

        An order MAY get divided into various sub orders, for example if the SKUs are being shipped from different warehouse.  # noqa: E501

        :param suborders: The suborders of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501
        :type: list[OrderSearchResponseServiceResponseOrdersearchresponseSuborders]
        """

        self._suborders = suborders

    @property
    def links(self):
        """Gets the links of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501


        :return: The links of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501
        :rtype: OrderSearchResponseServiceResponseOrdersearchresponseLinks1
        """
        return self._links

    @links.setter
    def links(self, links):
        """Sets the links of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.


        :param links: The links of this OrderSearchResponseServiceResponseOrdersearchresponseOrders.  # noqa: E501
        :type: OrderSearchResponseServiceResponseOrdersearchresponseLinks1
        """

        self._links = links

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.swagger_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value
        if issubclass(OrderSearchResponseServiceResponseOrdersearchresponseOrders, dict):
            for key, value in self.items():
                result[key] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, OrderSearchResponseServiceResponseOrdersearchresponseOrders):
            return False

        return self.__dict__ == other.__dict__

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        return not self == other
